//+----------------------------------------------------------+
//|                                                          |
//|                       Momo_EA.mq4                        |
//|             Copyright  2009, Pro FX Experts             |
//|               Customer Name: Heiko                       |
//|                    Date: 18-May-2009                     |
//+----------------------------------------------------------+
#property copyright "Copyright  2009, Pro FX Experts"

extern int    MAGIC_NUMBER              = 20077512;

extern double Lots                      = 0.2;
extern int    Lot_Digits                = 1; // Do you trade on 1 or two digit lots
extern bool   ManageMoney               = false; 
extern int    Risk                      = 3; // Risk %
extern bool   AccountIsMicro            = false; // Do you trade on 1 or two digit lots

extern bool   Use_Session_1_Trade       = true;
extern string Session_1_Start           = "14:00";
extern string Session_1_Stop            = "18:00";

extern bool   Use_Session_2_Trade       = true;
extern string Session_2_Start           = "00:00";
extern string Session_2_Stop            = "06:00";

extern bool   Trade_Long                = true;      
extern bool   Trade_Short               = true; 

extern bool   Use_Re_Entry              = true;

extern bool   Use_TakeProfit            = true;
extern double TakeProfit                = 200;

extern bool   Use_Swing_Low_High_SL     = true;
extern bool   Use_Pips_SL               = false;
extern double StopLoss                  = 20;

extern int    Above_Below_MA_Entry      = 15; // Set pips 

extern bool   Aggressive_Mode           = true;
extern double BuyTrade_Level            = -0.0002;
extern double SellTrade_Level           =  0.0002;

extern bool   Conservative_Mode         = false;

extern bool   TrailingOrders            = true;
extern int    MA_Trailing_Pips          = 15;

extern bool   Use_Break_Even            = true;  
extern int    Break_Even_Pips           = 2;

extern string MACD_Settings             = "MACD_Settings";
extern int    Fast_EMA_Period           = 12;
extern int    Slow_EMA_Period           = 26;
extern int    Signal_Period             = 9;
extern int    MACD_Mode                 = 0; // 0 = Main , 1 = Signal
extern int    MACD_Price                = 0; // CLOSE=0, OPEN=1, HIGH=2, LOW=3, MEDIAN=4, TYPICAL=5, WEIGHTED=6 

extern string MA_Settings               = "MA_Settings";
extern int    MA_Period                 = 20; 
extern int    MA_Mode                   = 1; // 0 = sma, 1 = ema, 2 = smma, 3 = lwma
extern int    MA_Price                  = 0; // CLOSE=0, OPEN=1, HIGH=2, LOW=3, MEDIAN=4, TYPICAL=5, WEIGHTED=6 

extern bool   Show_Comment              = true;
extern string EAName                    = "Momo"; 

//----------------------------------------------------------------------------------------------------------// 
int magic,cnt,Slippage=3,Ticket;
string UseTPYN,UseSLYN,UseTrailYN,REYN,UseSWHLYN;
//----------------------------------------------------------------------------------------------------------// 
int init(){magic = MakeMagicNumber(MAGIC_NUMBER);}
int deinit(){return (0);}
//----------------------------------------------------------------------------------------------------------// 

int start(){
//----------------------------------------------------------------------------------------------------------// 
 RefreshRates();
 double MD0=0,MD1=0,MA0=0,TPB,TPS,SLB=0,SLS=0; 
 datetime LOTime=0;
 int LOType=3;
 
 LOTime = LastOrderTime(magic); 
 LOType = LastOrderType(magic); 
 
 MD0 = iMACD(NULL,0,Fast_EMA_Period,Slow_EMA_Period,Signal_Period,MACD_Price,MACD_Mode,0);
 MD1 = iMACD(NULL,0,Fast_EMA_Period,Slow_EMA_Period,Signal_Period,MACD_Price,MACD_Mode,1);
 MA0 = iMA(NULL,0,MA_Period,0,MA_Mode,MA_Price,0);
 
 string   date        = TimeToStr(TimeCurrent(),TIME_DATE);
 datetime Ses_1_Start = StrToTime(date+" "+Session_1_Start);
 datetime Ses_1_Stop  = StrToTime(date+" "+Session_1_Stop); 
 datetime Ses_2_Start = StrToTime(date+" "+Session_2_Start);
 datetime Ses_2_Stop  = StrToTime(date+" "+Session_2_Stop); 
//----------------------------------------------------------------------------------------------------------// 
 if(TrailingOrders) {Trail_Orders();}
 if(ManageMoney) Lots=LotSize();
//----------------------------------------------------------------------------------------------------------// 
if(Use_Break_Even==true){
 for(cnt=0;cnt<OrdersTotal();cnt++)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       // Print("------ ",OrderLots()*0.7, " : ",NormalizeDouble(Lots/2,Lot_Digits)," : ",LotSize());
       
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
         
         {
            if(CountBuys(magic)>0 && OrderType()==OP_BUY && OrderLots()*0.7<=NormalizeDouble(Lots/2,Lot_Digits) && OrderStopLoss()<=OrderOpenPrice()) 
            {if(OrderStopLoss()<OrderOpenPrice())
               {OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Break_Even_Pips*Point,OrderTakeProfit(),0,White);}}
           
            if(CountSells(magic)>0 && OrderType()==OP_SELL && OrderLots()*0.7<=NormalizeDouble(Lots/2,Lot_Digits) && OrderStopLoss()>=OrderOpenPrice())
            {if(OrderStopLoss()>OrderOpenPrice())
            {OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Break_Even_Pips*Point,OrderTakeProfit(),0,Yellow);}}
     
      }
   }
}
//----------------------------------------------------------------------------------------------------------// 

if(Use_Re_Entry==true && CountBuys(magic)>0 && MD0>0 && MD1>0 && !ObjectFind("ReEnterUp "+Symbol())>=0) {
ReEnterUp();}

if(Use_Re_Entry==true && CountSells(magic)>0 && MD0<0 && MD1<0 && !ObjectFind("ReEnterDn "+Symbol())>=0) {
ReEnterDn();}

//----------------------------------------------------------------------------------------------------------// 

if((Use_Re_Entry==false && CountSells(magic)==0 && CountBuys(magic)==0 && ObjectFind("ReEnterUp "+Symbol())>=0) || 
   (Use_Re_Entry==true && CountSells(magic)==0 && CountBuys(magic)==0 && ObjectFind("ReEnterUp "+Symbol())>=0 && MD1<0 && High[0]<MA0) ||
   (Use_Re_Entry==true && CountSells(magic)==0 && CountBuys(magic)==0 && ObjectFind("ReEnterUp "+Symbol())>=0 && MD0<0 && MD1<0)) {
 ObjectDelete("ReEnterUp "+Symbol());}

if((Use_Re_Entry==false && CountSells(magic)==0 && CountBuys(magic)==0 && ObjectFind("ReEnterDn "+Symbol())>=0) || 
   (Use_Re_Entry==true && CountSells(magic)==0 && CountBuys(magic)==0 && ObjectFind("ReEnterDn "+Symbol())>=0 && MD1>0 && Low[0]>MA0) ||
   (Use_Re_Entry==true && CountSells(magic)==0 && CountBuys(magic)==0 && ObjectFind("ReEnterDn "+Symbol())>=0 && MD0>0 && MD1>0) 
   ) {
 ObjectDelete("ReEnterDn "+Symbol());}
 
//----------------------------------------------------------------------------------------------------------// 

  int up = 0, dw = 0;

  for (int i = 0; i<=10; i++) {
   if (iMACD(NULL,0,Fast_EMA_Period,Slow_EMA_Period,Signal_Period,PRICE_CLOSE,MODE_MAIN,i)>0) up++; 
   if (iMACD(NULL,0,Fast_EMA_Period,Slow_EMA_Period,Signal_Period,PRICE_CLOSE,MODE_MAIN,i)<0) dw++;}

//----------------------------------------------------------------------------------------------------------// 

if((CountBuys(magic)+CountSells(magic))>0)
   {
     for(int u=0;u<OrdersTotal();u++)
      {
       OrderSelect(u, SELECT_BY_POS, MODE_TRADES);
         if(OrderType()<=1 && OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
         {
            if(OrderType()==OP_BUY && OrderLots()==Lots && Ask-OrderOpenPrice()>StopLoss*Point) 
               { OrderClose(OrderTicket(), NormalizeDouble(OrderLots()/2,Lot_Digits), MarketInfo(OrderSymbol(), MODE_BID), 5, White);
                 }
            if(OrderType()==OP_SELL && OrderLots()==Lots && OrderOpenPrice()-Bid>StopLoss*Point)
              { OrderClose(OrderTicket(), NormalizeDouble(OrderLots()/2,Lot_Digits), MarketInfo(OrderSymbol(), MODE_ASK), 5, White);
                 Print(OrderLots(), " : ",Lots);
                 }
          }
     }
}
//----------------------------------------------------------------------------------------------------------// 
 double LL=0, HH=0;
 
 HH = High[iHighest(NULL,0,MODE_HIGH,5,0)];
 LL = Low[iLowest(NULL,0,MODE_LOW,5,0)];
 
if(Use_TakeProfit==true) {TPB=MA0+TakeProfit*Point;} else TPB=0;
if(Use_TakeProfit==true) {TPS=MA0-TakeProfit*Point;} else TPS=0;

if(Use_Pips_SL==true) {SLB=NormalizeDouble(MA0,Digits)-StopLoss*Point;} else 
if(Use_Swing_Low_High_SL==true) SLB=LL;

if(Use_Pips_SL==true) {SLS=NormalizeDouble(MA0,Digits)+StopLoss*Point;} else 
if(Use_Swing_Low_High_SL==true) SLS=HH;



if(Use_Pips_SL==true && Use_Swing_Low_High_SL==true) {
Alert("Please choose only one SL type"); 
return(0);}


//----------------------------------------------------------------------------------------------------------// 
if((TimeCurrent()>=Ses_1_Start && TimeCurrent()<Ses_1_Stop) || (TimeCurrent()>=Ses_2_Start && TimeCurrent()<Ses_2_Stop)){

if(Conservative_Mode==true) {
if(Trade_Long==true && CountBuys(magic)==0 && CountSells(magic)==0 && TimeCurrent()-BarTime()>LOTime && MD0>0 && !up>5 
   && Close[0]-Above_Below_MA_Entry*Point>MA0 && !ObjectFind("ReEnterUp "+Symbol())>=0){
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SLB,TPB,"Conserv_Buy",magic,0,Blue);}

if(Trade_Short==true && CountSells(magic)==0 && CountBuys(magic)==0 && TimeCurrent()-BarTime()>LOTime && MD0<0 && !dw>5 
   && Close[0]+Above_Below_MA_Entry*Point<MA0 && !ObjectFind("ReEnterDn "+Symbol())>=0){
  OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SLS,TPS,"Conserv_Sell",magic,0,Red);}
}
//---------------------------------------------
if(Aggressive_Mode==true) {
if(Trade_Long==true && CountBuys(magic)==0 && CountSells(magic)==0 && TimeCurrent()-BarTime()>LOTime && MD1<MD0 && MD0>BuyTrade_Level && !up>5 
   && Close[0]-Above_Below_MA_Entry*Point>MA0 && !ObjectFind("ReEnterUp "+Symbol())>=0){
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SLB,TPB,"Aggress_Buy",magic,0,Blue);}

if(Trade_Short==true && CountSells(magic)==0 && CountBuys(magic)==0 && TimeCurrent()-BarTime()>LOTime && MD1>MD0 && MD0<SellTrade_Level && !dw>5 
   && Close[0]+Above_Below_MA_Entry*Point<MA0 && !ObjectFind("ReEnterDn "+Symbol())>=0){
  OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SLS,TPS,"Aggress_Sell",magic,0,Red);}
}
//----------------------------------------------------------------------------------------------------------// 

//  Re-Enter Mode  //
if(Conservative_Mode==true) {
if(Trade_Long==true && CountBuys(magic)==0 && CountSells(magic)==0 && MD0>0  
   && Low[1]<MA0 && Close[0]-Above_Below_MA_Entry*Point>MA0 && ObjectFind("ReEnterUp "+Symbol())>=0){
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SLB,TPB,"Conserv_Buy",magic,0,Blue);}

if(Trade_Short==true && CountSells(magic)==0 && CountBuys(magic)==0 && MD0<0 
   && High[1]>MA0 && Close[0]+Above_Below_MA_Entry*Point<MA0 && ObjectFind("ReEnterDn "+Symbol())>=0){
  OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SLS,TPS,"Conserv_Sell",magic,0,Red);}
}
//---------------------------------------------
if(Aggressive_Mode==true) {
if(Trade_Long==true && CountBuys(magic)==0 && CountSells(magic)==0 && MD1<MD0 && MD0>BuyTrade_Level 
   && Low[1]<MA0 && Close[0]-Above_Below_MA_Entry*Point>MA0 && ObjectFind("ReEnterUp "+Symbol())>=0){
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SLB,TPB,"Aggress_Buy",magic,0,Blue);}

if(Trade_Short==true && CountSells(magic)==0 && CountBuys(magic)==0 && MD1>MD0 && MD0<SellTrade_Level 
   && High[1]>MA0 && Close[0]+Above_Below_MA_Entry*Point<MA0 && ObjectFind("ReEnterDn "+Symbol())>=0){
  OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SLS,TPS,"Aggress_Sell",magic,0,Red);}
}
}
//----------------------------------------------------------------------------------------------------------// 








if(Use_TakeProfit==true) {UseTPYN="Yes";} else {UseTPYN="No";}
if(Use_Pips_SL==true) {UseSLYN="Yes";} else {UseSLYN="No";}
if(Use_Swing_Low_High_SL==true) {UseSWHLYN="Yes";} else {UseSWHLYN="No";}
if(TrailingOrders==true) {UseTrailYN="Yes";} else {UseTrailYN="No";}
if(Use_Re_Entry==true) {REYN="Yes";} else {REYN="No";}


if(Show_Comment){
Comment ("\n                " + EAName +"   MagicNumber: " + magic 
		  +"\n               -------------------------------------------------"
		  +"\n               Current Server Time   : " + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)
        +"\n               Account Balance         : " + DoubleToStr(NormalizeDouble(AccountBalance(),2),2)
        +"\n               Account Free margin   : " + DoubleToStr(NormalizeDouble(AccountEquity(),2),2)		  
		  +"\n               Lots                          : " + DoubleToStr(Lots,2)
		  +"\n               Use Take Profit          : " + UseTPYN		  		  
		  +"\n               Take Profit pips          : " + DoubleToStr(NormalizeDouble(TakeProfit,0),0)
		  +"\n               Use Pips StopLoss       : " + UseSLYN		  
		  +"\n               StopLoss                    : " + DoubleToStr(NormalizeDouble(StopLoss,0),0)
		  +"\n               Use Swing H/L SL       : " + UseSWHLYN		  
		  +"\n               Use MA Trailing          : " + UseTrailYN 
		  +"\n               MA Trailing Pips         : " + MA_Trailing_Pips
		  +"\n               Re Enter mode           : " + REYN		  
		  
	/*	  +"\n               SLB               : " + NormalizeDouble(MA0,Digits)
		  +"\n               SLS               : " + SLS		  
		  +"\n               TM0               : " + TM0
		  +"\n               TM1               : " + TM1		  */
		  +"\n               ------------------------------------------------");
}


        ObjectCreate("CC", OBJ_LABEL, 0, 0, 0);
        ObjectSet("CC", OBJPROP_CORNER, 3);
        ObjectSet("CC", OBJPROP_XDISTANCE, 5);
        ObjectSet("CC", OBJPROP_YDISTANCE, 5);
        ObjectSet("CC", OBJPROP_BACK, true);
        ObjectSetText("CC", "Copyright  "+Year()+", Heiko - By Pro-Fx-Experts.com", 8, "Arial", Silver);


//----------------------------------------------------------------------------------------------------------// 

return (0);

}
//==========================================================================================================// 

void Trail_Orders(){
 double MA0=0;
 MA0 = iMA(NULL,0,MA_Period,0,MA_Mode,MA_Price,0);

 int err=GetLastError();
      for(cnt=0;cnt<OrdersTotal();cnt++)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderType()<=1 && OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
         {
            if(OrderType()==OP_BUY) 
            {if((Bid-OrderOpenPrice())>(Point*MA_Trailing_Pips) && OrderStopLoss()<(MA0-Point*MA_Trailing_Pips)-Point)
               {OrderModify(OrderTicket(),OrderOpenPrice(),MA0-Point*MA_Trailing_Pips,OrderTakeProfit(),0,Green);}}
           
            if(OrderType()==OP_SELL)
            {if(((OrderOpenPrice()-Ask)>(Point*MA_Trailing_Pips) && OrderStopLoss()>(MA0+Point*MA_Trailing_Pips)+Point) || ((OrderOpenPrice()-Ask)>(Point*MA_Trailing_Pips) && OrderStopLoss()==0))
            {OrderModify(OrderTicket(),OrderOpenPrice(),MA0+Point*MA_Trailing_Pips,OrderTakeProfit(),0,Red);}}
      }
   } 
} 

//+------------------------------------------------------------------+
int CountBuys(int MagicNumber)
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if( OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber )
   continue;
   
  if(OrderType()==OP_BUY)
   count++;
 }
 return(count);
}
//+------------------------------------------------------------------+
//| Calculate concurrent short position                              |
//+------------------------------------------------------------------+
int CountSells(int MagicNumber)
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol() || OrderMagicNumber() != MagicNumber )
   continue;
   
  if(OrderType()==OP_SELL)
  count++;
 }//for
 return(count);
}
//+------------------------------------------------------------------+

int MakeMagicNumber(int ExpertID)
{
   int SymbolCode  = 0;
   int MagicNumber = 0; 
   
   //---- Symbol() Code
        if( Symbol() == "AUDCAD" || Symbol() == "AUDCADm" ) { SymbolCode = 1000; }
   else if( Symbol() == "AUDJPY" || Symbol() == "AUDJPYm" ) { SymbolCode = 2000; }
   else if( Symbol() == "AUDNZD" || Symbol() == "AUDNZDm" ) { SymbolCode = 3000; }
   else if( Symbol() == "AUDUSD" || Symbol() == "AUDUSDm" ) { SymbolCode = 4000; }
   else if( Symbol() == "CHFJPY" || Symbol() == "CHFJPYm" ) { SymbolCode = 5000; }
   else if( Symbol() == "EURAUD" || Symbol() == "EURAUDm" ) { SymbolCode = 6000; }
   else if( Symbol() == "EURCAD" || Symbol() == "EURCADm" ) { SymbolCode = 7000; }
   else if( Symbol() == "EURCHF" || Symbol() == "EURCHFm" ) { SymbolCode = 8000; }
   else if( Symbol() == "EURGBP" || Symbol() == "EURGBPm" ) { SymbolCode = 9000; }
   else if( Symbol() == "EURJPY" || Symbol() == "EURJPYm" ) { SymbolCode = 2100; }
   else if( Symbol() == "EURUSD" || Symbol() == "EURUSDm" ) { SymbolCode = 1100; }
   else if( Symbol() == "GBPCHF" || Symbol() == "GBPCHFm" ) { SymbolCode = 1200; }
   else if( Symbol() == "GBPJPY" || Symbol() == "GBPJPYm" ) { SymbolCode = 1300; }
   else if( Symbol() == "GBPUSD" || Symbol() == "GBPUSDm" ) { SymbolCode = 1400; }
   else if( Symbol() == "NZDJPY" || Symbol() == "NZDJPYm" ) { SymbolCode = 1500; }
   else if( Symbol() == "NZDUSD" || Symbol() == "NZDUSDm" ) { SymbolCode = 1600; }
   else if( Symbol() == "USDCAD" || Symbol() == "USDCADm" ) { SymbolCode = 1700; }
   else if( Symbol() == "USDCHF" || Symbol() == "USDCHFm" ) { SymbolCode = 1800; }
   else if( Symbol() == "USDJPY" || Symbol() == "USDJPYm" ) { SymbolCode = 1900; }
   else { SymbolCode = 1111; }


   //---- Calculate MagicNumber
   MagicNumber = ExpertID+SymbolCode;
   return(MagicNumber);
}

 
//----------------------------------------------------------------------------------------------------------//
int BarTime(){
 int BarCount;
        if( Period() == 1 )    { BarCount = 1*60; }
   else if( Period() == 5 )    { BarCount = 5*60; }
   else if( Period() == 15 )   { BarCount = 15*60; }
   else if( Period() == 30 )   { BarCount = 30*60; }
   else if( Period() == 60 )   { BarCount = 60*60; }
   else if( Period() == 240 )  { BarCount = 4*60*60; }
   else if( Period() == 1440 ) { BarCount = 24*60*60; }
   else if( Period() == 10080 ){ BarCount = 30*24*60*60; } 
 return(BarCount);  
}
//----------------------------------------------------------------------------------------------------------// 
datetime LastOrderTime(int MagicNumber)
{
   int total = OrdersHistoryTotal();
   
   datetime cur_order = 0;
   datetime last_order=0;
   datetime LOTime=0;
 
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY);
      cur_order = OrderCloseTime();
     if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) { 
      if(cur_order>last_order)
      {
        last_order = cur_order; 
        LOTime = OrderCloseTime();
       }
     }     
   }
   return (LOTime);
}
//----------------------------------------------------------------------------------------------------------// 

double LotSize()
{
 //double lotMM = NormalizeDouble(AccountFreeMargin()*Risk/100000,1);
	  
	  if(AccountIsMicro==false) //Normal Account
	  { 
	  double lotMM = NormalizeDouble(AccountBalance()*Risk/100000,1);
	  
	     if(lotMM < 0.1)                   lotMM = Lots;
	     if(lotMM >= 1.0)                  lotMM = NormalizeDouble(lotMM,1);
	     if(lotMM >= 100)                  lotMM = 100;
	  }
	  else //Mini Account
	  {
	   lotMM = NormalizeDouble(AccountBalance()*Risk/100000,2);
	   
	     if(lotMM < 0.01)                  lotMM = Lots;
	     if(lotMM >= 1.0)                  lotMM = NormalizeDouble(lotMM,2);
	     if(lotMM >= 100)                  lotMM = 100;
	  }
	  
	  return (lotMM);
}

//----------------------------------------------------------------------------------------------------------// 
void ReEnterUp() { 
 ObjectCreate("ReEnterUp "+Symbol(), OBJ_ARROW, 0,Time[1],Ask); 
 ObjectSet("ReEnterUp "+Symbol(),OBJPROP_COLOR,DeepSkyBlue);
 ObjectSet("ReEnterUp "+Symbol(),OBJPROP_ARROWCODE,118);
 ObjectSet("ReEnterUp "+Symbol(),OBJPROP_WIDTH,2);
  return(0); 
}

void ReEnterDn() { 
 ObjectCreate("ReEnterDn "+Symbol(), OBJ_ARROW, 0,Time[1],Bid); 
 ObjectSet("ReEnterDn "+Symbol(),OBJPROP_COLOR,Tomato);
 ObjectSet("ReEnterDn "+Symbol(),OBJPROP_ARROWCODE,118);
 ObjectSet("ReEnterDn "+Symbol(),OBJPROP_WIDTH,2); 
  return(0); 
} 
//----------------------------------------------------------------------------------------------------------// 
int LastOrderType(int MagicNumber)
{
   int total = OrdersHistoryTotal();
   
   datetime cur_order = 0;
   datetime last_order=0;
   int LOType=3;
 
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY);
      cur_order = OrderCloseTime();
     if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) { 
      if(cur_order>last_order)
      {
        last_order = cur_order; 
        LOType = OrderType();
       }
     }     
   }
   return (LOType);
}
//----------------------------------------------------------------------------------------------------------// 


